pro read_genxcat, t0, t1, outdata, topdir=topdir, genfiles=genfiles, $
		initialize=initialize, sublevel=sublevel, $
	        dbfiles=dbfiles, catfiles=catfiles
;
;+   Name: rd_genxcat
;
;    Purpose: read a catalog which uses 'genx' format files
;
;    History:
;      9-Mar-1998 - S.L.Freeland - long planned 'gen' function
;                   finally implemented for TRACE  
;
;    Restrictions:
;       catalog files have GMT of first record embedded in file name
;
;    Calls:
;       file2time, time2file, restgen, 
; 
;-
;common read_genxcat, dbfiles, dbfids

initialize=keyword_set(initialize) or n_elements(catfiles) eq 0

if initialize then begin
  if n_elements(sublevel) eq 0 then sublevel=0
  if data_chk(topdir,/string,/scalar) then $
       tdir=get_logenv(topdir) else tdir=curdir()
  for i=0,sublevel-1 do tdir=concat_dir(tdir,'*')
  files=file_list(tdir,'*.genx',/cd)
endif

ndbf=n_elements(catfiles)
restgen,file=catfiles(0),structs
outdata=temporary(structs)
for i=1, ndbf-1 do begin
   restgen,file=catfiles(i),structs
   outdata=[outdata,temporary(structs)]     
endfor

if n_params() eq 1 then t0=temporary(outdata) 

return
end
